diff --git a/History.md b/History.md
index 9e3d80e..45b9efa 100644
--- a/History.md
+++ b/History.md
@@ -1,3 +1,6 @@
+2.2.0 / 2020-08-25
+==================
+  * Integrateing the clib-package into the main repo
 
 1.8.1 / 2017-08-21
 ==================
diff --git a/Makefile b/Makefile
index 116dbbb..27f3ec0 100644
--- a/Makefile
+++ b/Makefile
@@ -12,6 +12,7 @@ RM      = rm -f
 MKDIR   = mkdir -p
 
 SRC  = $(wildcard src/*.c)
+COMMON_SRC = $(wildcard src/common/*.c)
 SDEPS = $(wildcard deps/*/*.c)
 ODEPS = $(SDEPS:.c=.o)
 DEPS = $(filter-out $(ODEPS), $(SDEPS))
@@ -45,7 +46,7 @@ all: $(BINS)
 build: $(BINS)
 
 $(BINS): $(SRC) $(MAKEFILES) $(OBJS)
-	$(CC) $(CFLAGS) -o $@ src/$(@:.exe=).c $(OBJS) $(LDFLAGS)
+	$(CC) $(CFLAGS) -o $@ $(COMMON_SRC) src/$(@:.exe=).c $(OBJS) $(LDFLAGS)
 
 $(MAKEFILES):
 	$(MAKE) -C $@
diff --git a/clib.json b/clib.json
index a7a13e4..18d4a34 100644
--- a/clib.json
+++ b/clib.json
@@ -17,7 +17,6 @@
     "stephenmathieson/trim.c": "0.0.2",
     "which": "0.1.3",
     "stephenmathieson/str-flatten.c": "0.0.4",
-    "clib-package": "*",
     "commander": "1.3.2",
     "stephenmathieson/wiki-registry.c": "0.0.4",
     "stephenmathieson/case.c": "0.1.3",
@@ -30,6 +29,19 @@
     "logger": "0.0.1",
     "clibs/parson": "1.0.2",
     "clibs/http-get.c": "*",
-    "hash": "0.0.1"
+    "hash": "0.0.1",
+
+    "list": "*",
+    "stephenmathieson/substr.c": "0.1.2",
+    "stephenmathieson/mkdirp.c": "0.1.5",
+    "stephenmathieson/path-join.c": "0.0.6",
+    "stephenmathieson/parse-repo.c": "1.1.1",
+    "stephenmathieson/debug.c": "0.0.0",
+    "clib-cache": "0.2.0",
+    "stephenmathieson/tempdir.c": "0.0.2"
+  },
+  "development": {
+    "stephenmathieson/describe.h": "2.0.1",
+    "stephenmathieson/rimraf.c": "0.1.0"
   }
-}
\ No newline at end of file
+}
diff --git a/deps/assertion-macros/assertion-macros.h b/deps/assertion-macros/assertion-macros.h
new file mode 100644
index 0000000..d423903
--- /dev/null
+++ b/deps/assertion-macros/assertion-macros.h
@@ -0,0 +1,175 @@
+
+//
+// assertion-macros.h
+//
+// Copyright (c) 2014 Stephen Mathieson
+// MIT licensed
+//
+
+
+#ifndef ASSERTION_MACROS_H
+#define ASSERTION_MACROS_H 1
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+static int __assert_bail = 0;
+static int __assert_failures = 0;
+
+/*
+ * Bail at first failing assertion
+ */
+
+#define assert_bail() __assert_bail = !__assert_bail;
+
+/*
+ * Get the number of failed assertions
+ */
+
+#define assert_failures() __assert_failures
+
+/*
+ * Reset the number of failed assertions
+ */
+
+#define assert_reset() do {                                     \
+  __assert_failures = 0;                                        \
+} while(0);
+
+// don't clobber assert
+#ifndef assert
+#  define assert assert_ok
+#endif
+
+/*
+ * Assert that `expr` evaluates to something truthy
+ */
+
+#define assert_ok(expr) do {                                    \
+  if (!(expr)) {                                                \
+    __assert_failures++;                                        \
+    fprintf(                                                    \
+        stderr                                                  \
+      , "Assertion error: %s (%s:%d)\n"                         \
+      , #expr                                                   \
+      , __FILE__                                                \
+      , __LINE__                                                \
+    );                                                          \
+    if (__assert_bail) abort();                                 \
+  }                                                             \
+} while(0);
+
+/*
+ * Assert that `expr` is NULL
+ */
+
+#define assert_null(expr) do {                                  \
+  if ((expr) != NULL) {                                         \
+    __assert_failures++;                                        \
+    fprintf(                                                    \
+        stderr                                                  \
+      , "Assertion error: %s is NULL (%s:%d)\n"                 \
+      , #expr                                                   \
+      , __FILE__                                                \
+      , __LINE__                                                \
+    );                                                          \
+    if (__assert_bail) abort();                                 \
+  }                                                             \
+} while(0);
+
+/*
+ * Assert that `expr` is not NULL
+ */
+
+#define assert_not_null(expr) do {                              \
+  if ((expr) == NULL) {                                         \
+    __assert_failures++;                                        \
+    fprintf(                                                    \
+        stderr                                                  \
+      , "Assertion error: %s is not NULL (%s:%d)\n"             \
+      , #expr                                                   \
+      , __FILE__                                                \
+      , __LINE__                                                \
+    );                                                          \
+    if (__assert_bail) abort();                                 \
+  }                                                             \
+} while(0);
+
+/*
+ * Assert that `a` is equal to `b`
+ */
+
+#define assert_equal(a, b) do {                                 \
+  if (a != b) {                                                 \
+    __assert_failures++;                                        \
+    fprintf(                                                    \
+        stderr                                                  \
+      , "Assertion error: %d == %d (%s:%d)\n"                   \
+      , a                                                       \
+      , b                                                       \
+      , __FILE__                                                \
+      , __LINE__                                                \
+    );                                                          \
+    if (__assert_bail) abort();                                 \
+  }                                                             \
+} while(0);
+
+/*
+ * Assert that `a` is not equal to `b`
+ */
+
+#define assert_not_equal(a, b) do {                             \
+  if (a == b) {                                                 \
+    __assert_failures++;                                        \
+    fprintf(                                                    \
+        stderr                                                  \
+      , "Assertion error: %d != %d (%s:%d)\n"                   \
+      , a                                                       \
+      , b                                                       \
+      , __FILE__                                                \
+      , __LINE__                                                \
+    );                                                          \
+    if (__assert_bail) abort();                                 \
+  }                                                             \
+} while(0);
+
+/*
+ * Assert that `a` is equal to `b`
+ */
+
+#define assert_str_equal(a, b) do {                             \
+  if (0 != strcmp(a, b))  {                                     \
+    __assert_failures++;                                        \
+    fprintf(                                                    \
+        stderr                                                  \
+      , "Assertion error: \"%s\" == \"%s\" (%s:%d)\n"           \
+      , a                                                       \
+      , b                                                       \
+      , __FILE__                                                \
+      , __LINE__                                                \
+    );                                                          \
+    if (__assert_bail) abort();                                 \
+  }                                                             \
+} while(0);
+
+/*
+ * Assert that `a` is not equal to `b`
+ */
+
+#define assert_str_not_equal(a, b) do {                         \
+  if (0 == strcmp(a, b))  {                                     \
+    __assert_failures++;                                        \
+    fprintf(                                                    \
+        stderr                                                  \
+      , "Assertion error: \"%s\" != \"%s\" (%s:%d)\n"           \
+      , a                                                       \
+      , b                                                       \
+      , __FILE__                                                \
+      , __LINE__                                                \
+    );                                                          \
+    if (__assert_bail) abort();                                 \
+  }                                                             \
+} while(0);
+
+#endif
diff --git a/deps/assertion-macros/package.json b/deps/assertion-macros/package.json
new file mode 100644
index 0000000..b3fbed7
--- /dev/null
+++ b/deps/assertion-macros/package.json
@@ -0,0 +1,9 @@
+{
+  "name": "assertion-macros",
+  "version": "0.2.1",
+  "repo": "stephenmathieson/assertion-macros.h",
+  "description": "Simple assertion macros",
+  "keywords": [ "assert", "assertions" ],
+  "license": "MIT",
+  "src": [ "assertion-macros.h" ]
+}
diff --git a/deps/clib-package/clib.json b/deps/clib-package/clib.json
deleted file mode 100644
index 4c48790..0000000
--- a/deps/clib-package/clib.json
+++ /dev/null
@@ -1,29 +0,0 @@
-{
-  "name": "clib-package",
-  "version": "1.0.9",
-  "repo": "clibs/clib-package",
-  "src": [
-    "src/clib-package.h",
-    "src/clib-package.c"
-  ],
-  "dependencies": {
-    "list": "*",
-    "clibs/parson": "1.0.2",
-    "stephenmathieson/substr.c": "0.1.2",
-    "clibs/http-get.c": "0.2.1",
-    "stephenmathieson/mkdirp.c": "0.1.5",
-    "jwerle/fs.c": "0.2.0",
-    "stephenmathieson/path-join.c": "0.0.6",
-    "strdup": "0.0.0",
-    "stephenmathieson/parse-repo.c": "1.1.1",
-    "logger": "0.0.1",
-    "stephenmathieson/debug.c": "0.0.0",
-    "clib-cache": "0.2.0",
-    "stephenmathieson/tempdir.c": "0.0.2",
-    "hash": "0.0.1"
-  },
-  "development": {
-    "stephenmathieson/describe.h": "2.0.1",
-    "stephenmathieson/rimraf.c": "0.1.0"
-  }
-}
\ No newline at end of file
diff --git a/deps/commander/clib.json b/deps/commander/clib.json
deleted file mode 100644
index b601ca7..0000000
--- a/deps/commander/clib.json
+++ /dev/null
@@ -1,9 +0,0 @@
-{
-  "name": "commander",
-  "version": "1.3.2",
-  "repo": "clibs/commander",
-  "description": "Command-line argument parser",
-  "keywords": ["cli", "command", "parser", "argv", "args", "options"],
-  "license": "MIT",
-  "src": ["src/commander.h", "src/commander.c"]
-}
diff --git a/deps/describe/describe.h b/deps/describe/describe.h
new file mode 100644
index 0000000..073bd22
--- /dev/null
+++ b/deps/describe/describe.h
@@ -0,0 +1,65 @@
+
+//
+// describe.h
+//
+// Copyright (c) 2013 Stephen Mathieson
+// Copyright (c) 2015 Michael Phan-Ba
+// MIT licensed
+//
+
+
+#ifndef DESCRIBE_H
+#define DESCRIBE_H 1
+
+#include "console-colors/console-colors.h"
+#include "assertion-macros/assertion-macros.h"
+
+#define DESCRIBE_VERSION "1.1.0"
+#define DESCRIBE_OK      "✓"
+#define DESCRIBE_FAIL    "✖"
+
+void __describe_after_spec(const char *specification, int before) {
+  if (assert_failures() == before) {
+    cc_fprintf(
+        CC_FG_DARK_GREEN
+      , stdout
+      , "    %s"
+      , DESCRIBE_OK
+    );
+  } else {
+    cc_fprintf(
+        CC_FG_DARK_RED
+      , stdout
+      , "    %s"
+      , DESCRIBE_FAIL
+    );
+  }
+  cc_fprintf(
+      CC_FG_GRAY
+    , stdout
+    , " %s\n"
+    , specification
+  );
+}
+
+/*
+ * Describe `suite` with `title`
+ */
+
+#define describe(title) for (                     \
+  int __run = 0;                                  \
+  __run++ == 0 && printf("\n  %s\n", title);      \
+  printf("\n")                                    \
+)
+
+/*
+ * Describe `fn` with `specification`
+ */
+
+#define it(specification) for (                   \
+  int __before = assert_failures(), __run = 0;    \
+  __run++ == 0;                                   \
+  __describe_after_spec(specification, __before)  \
+)
+
+#endif
diff --git a/deps/describe/package.json b/deps/describe/package.json
new file mode 100644
index 0000000..ec496a9
--- /dev/null
+++ b/deps/describe/package.json
@@ -0,0 +1,13 @@
+{
+  "name": "describe",
+  "version": "2.0.1",
+  "repo": "stephenmathieson/describe.h",
+  "description": "Simple BDD describe test thingy",
+  "keywords": [ "testing", "bdd", "assert", "describe" ],
+  "license": "MIT",
+  "src": [ "describe.h" ],
+  "dependencies": {
+    "stephenmathieson/assertion-macros.h": "0.2.1",
+    "Constellation/console-colors.c": "1.0.1"
+  }
+}
diff --git a/deps/fs/package.json b/deps/fs/package.json
deleted file mode 100644
index 5075fdf..0000000
--- a/deps/fs/package.json
+++ /dev/null
@@ -1,22 +0,0 @@
-{
-  "name": "fs",
-  "version": "0.1.2",
-  "description": "File system API much like Node's fs module",
-  "repo": "jwerle/fs.c",
-  "src": ["fs.h", "fs.c"],
-  "scripts": {
-    "test": "make test"
-  },
-  "repository": {
-    "type": "git",
-    "url": "git@github.com:jwerle/fs.c.git"
-  },
-  "keywords": [
-    "fs"
-  ],
-  "author": "Joseph Werle",
-  "license": "MIT",
-  "bugs": {
-    "url": "https://github.com/jwerle/fs.c/issues"
-  }
-}
diff --git a/deps/hash/clib.json b/deps/hash/clib.json
deleted file mode 100644
index 1b3d49e..0000000
--- a/deps/hash/clib.json
+++ /dev/null
@@ -1,9 +0,0 @@
-{
-  "name": "hash",
-  "version": "0.0.1",
-  "repo": "clibs/hash",
-  "description": "Hash wrapper around khash",
-  "keywords": ["hash", "khash", "container"],
-  "license": "MIT",
-  "src": ["hash.c", "hash.h", "khash.h"]
-}
\ No newline at end of file
diff --git a/deps/http-get/package.json b/deps/http-get/package.json
deleted file mode 100644
index 32cbc92..0000000
--- a/deps/http-get/package.json
+++ /dev/null
@@ -1,12 +0,0 @@
-{
-  "name": "http-get",
-  "version": "0.1.1",
-  "repo": "stephenmathieson/http-get.c",
-  "description": "Simple HTTP GET requests backed by libcurl",
-  "keywords": [ "http", "curl", "get", "download" ],
-  "license": "MIT",
-  "src": [
-    "src/http-get.c",
-    "src/http-get.h"
-  ]
-}
diff --git a/deps/logger/clib.json b/deps/logger/clib.json
deleted file mode 100644
index c7d1bba..0000000
--- a/deps/logger/clib.json
+++ /dev/null
@@ -1,9 +0,0 @@
-{
-  "name": "logger",
-  "version": "0.0.1",
-  "repo": "clibs/logger",
-  "src": ["logger.h"],
-  "dependencies": {
-    "Constellation/console-colors.c": "1.0.1"
-  }
-}
diff --git a/deps/parson/clib.json b/deps/parson/clib.json
deleted file mode 100644
index ee9265c..0000000
--- a/deps/parson/clib.json
+++ /dev/null
@@ -1,12 +0,0 @@
-{
-  "name": "parson",
-  "version": "1.0.2",
-  "repo": "clibs/parson",
-  "description": "Small json parser and reader",
-  "keywords": [ "json", "parser" ],
-  "license": "MIT",
-  "src": [
-    "parson.c",
-    "parson.h"
-  ]
-}
diff --git a/deps/str-concat/clib.json b/deps/str-concat/clib.json
deleted file mode 100644
index 957032a..0000000
--- a/deps/str-concat/clib.json
+++ /dev/null
@@ -1,13 +0,0 @@
-
-{
-  "name": "str-concat",
-  "version": "0.0.2",
-  "repo": "darthtrevino/str-concat",
-  "description": "Returns the malloc'ed result of two c-strings concatenated.",
-  "keywords": [ "string", "concat" ],
-  "license": "MIT",
-  "src": [
-    "src/str-concat.c",
-    "src/str-concat.h"
-  ]
-}
diff --git a/deps/strdup/clib.json b/deps/strdup/package.json
similarity index 81%
rename from deps/strdup/clib.json
rename to deps/strdup/package.json
index 8da5c14..db8a7de 100644
--- a/deps/strdup/clib.json
+++ b/deps/strdup/package.json
@@ -1,10 +1,10 @@
 {
   "name": "strdup",
-  "version": "0.1.5",
+  "version": "0.0.0",
   "repo": "clibs/strdup",
   "description": "drop-in replacement for strdup(3) from libc",
   "keywords": [ "string", "copy" ],
-  "license": "Expat",
+  "license": "MIT",
   "src": [
     "strdup.c",
     "strdup.h"
diff --git a/deps/strdup/strdup.c b/deps/strdup/strdup.c
index f34bd5d..35ea993 100644
--- a/deps/strdup/strdup.c
+++ b/deps/strdup/strdup.c
@@ -12,24 +12,12 @@
 #include <string.h>
 #include "strdup.h"
 
-#ifndef strdup
-
 char *
 strdup(const char *str) {
-  if (NULL == (char *) str) {
-    return NULL;
-  }
-
   int len = strlen(str) + 1;
   char *buf = malloc(len);
-
-  if (buf) {
-    memset(buf, 0, len);
-    memcpy(buf, str, len - 1);
-  }
+  if (buf) memcpy(buf, str, len);
   return buf;
 }
 
-#endif
-
 #endif /* HAVE_STRDUP */
diff --git a/deps/strdup/strdup.h b/deps/strdup/strdup.h
index cd75dd9..1566205 100644
--- a/deps/strdup/strdup.h
+++ b/deps/strdup/strdup.h
@@ -18,9 +18,7 @@
  * copy of `str`, or `NULL` on failure.
  */
 
-#ifndef strdup
 char *
 strdup(const char *str);
-#endif
 
 #endif /* HAVE_STRDUP */
diff --git a/deps/which/clib.json b/deps/which/clib.json
deleted file mode 100644
index e8044fd..0000000
--- a/deps/which/clib.json
+++ /dev/null
@@ -1,15 +0,0 @@
-{
-  "name": "which",
-  "version": "0.1.3",
-  "repo": "clibs/which",
-  "description": "Locate executable via PATH or given string",
-  "keywords": ["lookup", "which", "locate", "find", "path", "bin", "executable"],
-  "license": "MIT",
-  "src": ["src/which.c", "src/which.h"],
-  "dependencies": {
-    "strdup": "0.0.0"
-  },
-  "development": {
-    "stephenmathieson/describe.h": "1.0.0"
-  }
-}
diff --git a/deps/wildcardcmp/clib.json b/deps/wildcardcmp/clib.json
deleted file mode 100644
index 5dd15bf..0000000
--- a/deps/wildcardcmp/clib.json
+++ /dev/null
@@ -1,9 +0,0 @@
-{
-  "name": "wildcardcmp",
-  "version": "0.0.0",
-  "repo": "clibs/wildcardcmp",
-  "description": "simple wildcard string comparison",
-  "keywords": ["wildcard", "string", "comparison"],
-  "license": "MIT",
-  "src": ["wildcardcmp.c", "wildcardcmp.h"]
-}
diff --git a/src/clib-build.c b/src/clib-build.c
index 3d4182d..14197dd 100644
--- a/src/clib-build.c
+++ b/src/clib-build.c
@@ -27,7 +27,7 @@
 #include <unistd.h>
 #endif
 
-#include <clib-package/clib-package.h>
+#include "common/clib-package.h"
 #include <clib-cache/cache.h>
 
 #include <str-flatten/str-flatten.h>
diff --git a/src/clib-configure.c b/src/clib-configure.c
index 2a66074..b35df87 100644
--- a/src/clib-configure.c
+++ b/src/clib-configure.c
@@ -27,7 +27,7 @@
 #include <unistd.h>
 #endif
 
-#include <clib-package/clib-package.h>
+#include "common/clib-package.h"
 #include <clib-cache/cache.h>
 
 #include <str-flatten/str-flatten.h>
diff --git a/src/clib-init.c b/src/clib-init.c
index 1411366..be6df3a 100644
--- a/src/clib-init.c
+++ b/src/clib-init.c
@@ -12,7 +12,7 @@
 #include "fs/fs.h"
 #include "asprintf/asprintf.h"
 #include "commander/commander.h"
-#include "clib-package/clib-package.h"
+#include "common/clib-package.h"
 #include "logger/logger.h"
 #include "debug/debug.h"
 #include "parson/parson.h"
diff --git a/src/clib-install.c b/src/clib-install.c
index 081f717..3115d25 100644
--- a/src/clib-install.c
+++ b/src/clib-install.c
@@ -14,7 +14,7 @@
 #include <libgen.h>
 #include "fs/fs.h"
 #include "commander/commander.h"
-#include "clib-package/clib-package.h"
+#include "common/clib-package.h"
 #include "clib-cache/cache.h"
 #include "http-get/http-get.h"
 #include "logger/logger.h"
diff --git a/src/clib-search.c b/src/clib-search.c
index d2d9bda..c34e45c 100644
--- a/src/clib-search.c
+++ b/src/clib-search.c
@@ -17,7 +17,7 @@
 #include "http-get/http-get.h"
 #include "asprintf/asprintf.h"
 #include "wiki-registry/wiki-registry.h"
-#include "clib-package/clib-package.h"
+#include "common/clib-package.h"
 #include "console-colors/console-colors.h"
 #include "strdup/strdup.h"
 #include "logger/logger.h"
diff --git a/src/clib-update.c b/src/clib-update.c
index 23f220f..8a70df4 100644
--- a/src/clib-update.c
+++ b/src/clib-update.c
@@ -14,7 +14,7 @@
 #include <libgen.h>
 #include "fs/fs.h"
 #include "commander/commander.h"
-#include "clib-package/clib-package.h"
+#include "common/clib-package.h"
 #include "clib-cache/cache.h"
 #include "http-get/http-get.h"
 #include "logger/logger.h"
diff --git a/src/clib-upgrade.c b/src/clib-upgrade.c
index 3ffea74..eec1b59 100644
--- a/src/clib-upgrade.c
+++ b/src/clib-upgrade.c
@@ -15,7 +15,7 @@
 #include <asprintf/asprintf.h>
 #include "fs/fs.h"
 #include "commander/commander.h"
-#include "clib-package/clib-package.h"
+#include "common/clib-package.h"
 #include "clib-cache/cache.h"
 #include "http-get/http-get.h"
 #include "logger/logger.h"
diff --git a/deps/clib-package/clib-package.c b/src/common/clib-package.c
similarity index 100%
rename from deps/clib-package/clib-package.c
rename to src/common/clib-package.c
diff --git a/deps/clib-package/clib-package.h b/src/common/clib-package.h
similarity index 100%
rename from deps/clib-package/clib-package.h
rename to src/common/clib-package.h
diff --git a/src/version.h b/src/version.h
index dd33bd3..1854b31 100644
--- a/src/version.h
+++ b/src/version.h
@@ -7,5 +7,5 @@
 //
 
 #ifndef CLIB_VERSION
-#define CLIB_VERSION "2.1.14"
+#define CLIB_VERSION "2.2.0"
 #endif
diff --git a/test.sh b/test.sh
index 41a8108..1c7474e 100755
--- a/test.sh
+++ b/test.sh
@@ -17,4 +17,17 @@ for t in $TESTS; do
 done
 echo
 
+
+printf "\nRunning clib package tests\n\n"
+cd test/package && make clean
+
+if ! make test; then
+    EXIT_CODE=1
+fi
+
+cd ../../
+
+
+print $EXIT_CODE
+
 exit $EXIT_CODE
diff --git a/test/package/Makefile b/test/package/Makefile
new file mode 100644
index 0000000..8d0373d
--- /dev/null
+++ b/test/package/Makefile
@@ -0,0 +1,36 @@
+
+CC ?= cc
+VALGRIND ?= valgrind
+TEST_RUNNER ?=
+
+SRC = ../../src/common/clib-package.c
+DEPS += $(wildcard ../../deps/*/*.c)
+OBJS = $(SRC:.c=.o) $(DEPS:.c=.o)
+TEST_SRC = $(wildcard *.c)
+TEST_OBJ = $(TEST_SRC:.c=.o)
+TEST_BIN = $(TEST_SRC:.c=)
+
+CFLAGS += -std=c99 -Wall -I../../src/common -I../../deps -DHAVE_PTHREADS -pthread -g
+LDFLAGS = -lcurl
+VALGRIND_OPTS ?= --leak-check=full --error-exitcode=3
+
+.DEFAULT_GOAL := test
+
+test: $(TEST_BIN)
+	$(foreach t, $^, $(TEST_RUNNER) ./$(t) || exit 1;)
+
+valgrind: TEST_RUNNER=$(VALGRIND) $(VALGRIND_OPTS)
+valgrind: test
+
+example: example.o $(OBJS)
+
+package-%: package-%.o $(OBJS)
+	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)
+
+clean:
+	rm -f $(OBJS)
+	rm -f $(TEST_OBJ)
+	rm -f $(TEST_BIN)
+	rm -rf test/fixtures
+
+.PHONY: test valgrind clean
diff --git a/test/package/clib.json b/test/package/clib.json
new file mode 100644
index 0000000..22949b5
--- /dev/null
+++ b/test/package/clib.json
@@ -0,0 +1,8 @@
+{
+  "name": "clib-package-test-fixture",
+  "version": "0.0.0",
+  "repo": "clibs/no-such-repo",
+  "dependencies": {
+    "list": "*"
+  }
+}
diff --git a/test/package/package-dependency-new b/test/package/package-dependency-new
new file mode 100755
index 0000000..85b3cb3
Binary files /dev/null and b/test/package/package-dependency-new differ
diff --git a/test/package/package-dependency-new.c b/test/package/package-dependency-new.c
new file mode 100644
index 0000000..4aa096a
--- /dev/null
+++ b/test/package/package-dependency-new.c
@@ -0,0 +1,43 @@
+
+#include "describe/describe.h"
+#include "clib-package.h"
+
+int
+main() {
+  curl_global_init(CURL_GLOBAL_ALL);
+
+  describe("clib_package_dependency_new") {
+    it("should return NULL when given bad input") {
+      assert(NULL == clib_package_dependency_new("foo/bar", NULL));
+      assert(NULL == clib_package_dependency_new(NULL, "foo/bar"));
+    }
+
+    it("should return a clib-dependency when given valid input") {
+      clib_package_dependency_t *dep = clib_package_dependency_new("foo/bar", "1.2.3");
+      assert(dep);
+      assert_str_equal("foo", dep->author);
+      assert_str_equal("bar", dep->name);
+      assert_str_equal("1.2.3", dep->version);
+      clib_package_dependency_free(dep);
+    }
+
+    it("should transform \"*\" to \"master\"") {
+      clib_package_dependency_t *dep = clib_package_dependency_new("foo/bar", "*");
+      assert(dep);
+      assert_str_equal("master", dep->version);
+      clib_package_dependency_free(dep);
+    }
+
+    it("should default to \"clibs\" when no repo author is given") {
+      clib_package_dependency_t *dep = clib_package_dependency_new("foo", "master");
+      assert(dep);
+      assert_str_equal("clibs", dep->author);
+      assert_str_equal("master", dep->version);
+      clib_package_dependency_free(dep);
+    }
+  }
+
+  curl_global_cleanup();
+
+  return assert_failures();
+}
diff --git a/test/package/package-install b/test/package/package-install
new file mode 100755
index 0000000..dee5fae
Binary files /dev/null and b/test/package/package-install differ
diff --git a/test/package/package-install-dependencies b/test/package/package-install-dependencies
new file mode 100755
index 0000000..b6d317d
Binary files /dev/null and b/test/package/package-install-dependencies differ
diff --git a/test/package/package-install-dependencies.c b/test/package/package-install-dependencies.c
new file mode 100644
index 0000000..268539e
--- /dev/null
+++ b/test/package/package-install-dependencies.c
@@ -0,0 +1,102 @@
+
+#include "describe/describe.h"
+#include "rimraf/rimraf.h"
+#include "fs/fs.h"
+#include "clib-package.h"
+
+int
+main() {
+  curl_global_init(CURL_GLOBAL_ALL);
+  clib_package_set_opts((clib_package_opts_t) {
+    .skip_cache = 1,
+    .prefix = 0,
+    .force = 1,
+  });
+
+  describe("clib_package_install_dependencies") {
+    it("should return -1 when given a bad package") {
+      assert(-1 == clib_package_install_dependencies(NULL, "./deps", 0));
+    }
+
+    it("should install the dep in its own directory") {
+      clib_package_t *dep = clib_package_new_from_slug("stephenmathieson/mkdirp.c", 0);
+      assert(dep);
+      assert(0 == clib_package_install_dependencies(dep, "./test/fixtures/", 0));
+      assert(0 == fs_exists("./test/fixtures/"));
+      assert(0 == fs_exists("./test/fixtures/path-normalize"));
+      clib_package_free(dep);
+      rimraf("./test/fixtures/");
+    }
+
+    it("should install the dependency's package.json") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/mkdirp.c", 0);
+      assert(pkg);
+      assert(0 == clib_package_install_dependencies(pkg, "./test/fixtures/", 0));
+      assert(0 == fs_exists("./test/fixtures/path-normalize/package.json"));
+      clib_package_free(pkg);
+      rimraf("./test/fixtures/");
+    }
+
+    it("should install the dependency's sources") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/mkdirp.c", 0);
+      assert(pkg);
+      assert(0 == clib_package_install_dependencies(pkg, "./test/fixtures/", 0));
+      assert(0 == fs_exists("./test/fixtures/path-normalize/path-normalize.c"));
+      assert(0 == fs_exists("./test/fixtures/path-normalize/path-normalize.h"));
+      clib_package_free(pkg);
+      rimraf("./test/fixtures");
+    }
+
+    it("should install the dependency's dependencies") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/rimraf.c", 0);
+      assert(pkg);
+      assert(0 == clib_package_install_dependencies(pkg, "./test/fixtures/", 0));
+      // deps
+      assert(0 == fs_exists("./test/fixtures/path-join/"));
+      assert(0 == fs_exists("./test/fixtures/path-join/package.json"));
+      assert(0 == fs_exists("./test/fixtures/path-join/path-join.c"));
+      assert(0 == fs_exists("./test/fixtures/path-join/path-join.h"));
+      // deps' deps
+      assert(0 == fs_exists("./test/fixtures/str-ends-with/"));
+      assert(0 == fs_exists("./test/fixtures/str-ends-with/package.json"));
+      assert(0 == fs_exists("./test/fixtures/str-ends-with/str-ends-with.h"));
+      assert(0 == fs_exists("./test/fixtures/str-ends-with/str-ends-with.c"));
+      assert(0 == fs_exists("./test/fixtures/str-starts-with/"));
+      assert(0 == fs_exists("./test/fixtures/str-starts-with/package.json"));
+      assert(0 == fs_exists("./test/fixtures/str-starts-with/str-starts-with.h"));
+      assert(0 == fs_exists("./test/fixtures/str-starts-with/str-starts-with.c"));
+      clib_package_free(pkg);
+      rimraf("./test/fixtures");
+    }
+
+    it("should handle unresolved packages") {
+      char json[] =
+        "{"
+        "  \"dependencies\": {"
+        "    \"linenoise\": \"*\","
+        "    \"stephenmathieson/substr.c\": \"*\","
+        "    \"stephenmathieson/emtter.c\": \"*\""
+        "  }"
+        "}";
+
+      clib_package_t *pkg = clib_package_new(json, 0);
+      assert(pkg);
+
+      int r = clib_package_install_dependencies(pkg, "./test/fixtures/", 0);
+      // should fail
+      assert(-1 == r);
+
+      assert(0 == fs_exists("./test/fixtures/linenoise/package.json"));
+      assert(0 == fs_exists("./test/fixtures/substr/package.json"));
+      assert(-1 == fs_exists("./test/fixtures/emtter/"));
+
+      clib_package_free(pkg);
+      rimraf("./test/fixtures");
+    }
+  }
+
+  curl_global_cleanup();
+  clib_package_cleanup();
+
+  return assert_failures();
+}
diff --git a/test/package/package-install-dev-dependencies b/test/package/package-install-dev-dependencies
new file mode 100755
index 0000000..729a9cd
Binary files /dev/null and b/test/package/package-install-dev-dependencies differ
diff --git a/test/package/package-install-dev-dependencies.c b/test/package/package-install-dev-dependencies.c
new file mode 100644
index 0000000..53977d7
--- /dev/null
+++ b/test/package/package-install-dev-dependencies.c
@@ -0,0 +1,48 @@
+
+#include "describe/describe.h"
+#include "rimraf/rimraf.h"
+#include "fs/fs.h"
+#include "clib-package.h"
+
+int
+main() {
+  curl_global_init(CURL_GLOBAL_ALL);
+  clib_package_set_opts((clib_package_opts_t) {
+    .skip_cache = 1,
+    .prefix = 0,
+    .force = 1,
+  });
+
+  describe("clib_package_install_development") {
+    it("should return -1 when given a bad package") {
+      assert(-1 == clib_package_install_development(NULL, "./deps", 0));
+    }
+
+    it("should return -1 when given a bad dir") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/mkdirp.c", 0);
+      assert(pkg);
+      assert(-1 == clib_package_install_development(pkg, NULL, 0));
+      clib_package_free(pkg);
+    }
+
+    it("should install the package's development dependencies") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/trim.c@0.0.2", 0);
+      assert(pkg);
+      assert(0 == clib_package_install_development(pkg, "./test/fixtures", 0));
+      assert(0 == fs_exists("./test/fixtures/describe"));
+      assert(0 == fs_exists("./test/fixtures/describe/describe.h"));
+      assert(0 == fs_exists("./test/fixtures/describe/package.json"));
+      assert(0 == fs_exists(
+        "./test/fixtures/assertion-macros/assertion-macros.h"
+      ));
+      assert(0 == fs_exists("./test/fixtures/assertion-macros/package.json"));
+      rimraf("./test/fixtures");
+      clib_package_free(pkg);
+    }
+  }
+
+  curl_global_cleanup();
+  clib_package_cleanup();
+
+  return assert_failures();
+}
diff --git a/test/package/package-install.c b/test/package/package-install.c
new file mode 100644
index 0000000..e65673b
--- /dev/null
+++ b/test/package/package-install.c
@@ -0,0 +1,159 @@
+
+#include <clib-package.h>
+#include "describe/describe.h"
+#include "rimraf/rimraf.h"
+#include "fs/fs.h"
+#include "clib-package.h"
+
+int
+main() {
+  curl_global_init(CURL_GLOBAL_ALL);
+  clib_package_set_opts((clib_package_opts_t) {
+    .skip_cache = 1,
+    .prefix = 0,
+    .force = 1,
+  });
+
+  describe("clib_package_install") {
+    it("should return -1 when given a bad package") {
+      assert(-1 == clib_package_install(NULL, "./deps", 0));
+    }
+
+    it("should install the pkg in its own directory") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/case.c@0.1.0", 0);
+      assert(pkg);
+      assert(0 == clib_package_install(pkg, "./test/fixtures/", 0));
+      assert(0 == fs_exists("./test/fixtures/"));
+      assert(0 == fs_exists("./test/fixtures/case"));
+      clib_package_free(pkg);
+      rimraf("./test/fixtures/");
+    }
+
+    it("should install the package's clib.json or package.json") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/case.c@0.1.0", 0);
+      assert(pkg);
+      assert(0 == clib_package_install(pkg, "./test/fixtures/", 1));
+      assert(
+        0 == fs_exists("./test/fixtures/case/package.json") ||
+        0 == fs_exists("./test/fixtures/case/clib.json"));
+      clib_package_free(pkg);
+      rimraf("./test/fixtures/");
+    }
+
+    it("should install the package's sources") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/case.c@0.1.0", 0);
+      assert(pkg);
+      assert(0 == clib_package_install(pkg, "./test/fixtures/", 0));
+      assert(0 == fs_exists("./test/fixtures/case/case.c"));
+      assert(0 == fs_exists("./test/fixtures/case/case.h"));
+      clib_package_free(pkg);
+      rimraf("./test/fixtures");
+    }
+
+    it("should install the package's dependencies") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/mkdirp.c@master", 0);
+      assert(pkg);
+      assert(0 == clib_package_install(pkg, "./test/fixtures/", 0));
+      assert(0 == fs_exists("./test/fixtures/path-normalize/"));
+      assert(0 == fs_exists("./test/fixtures/path-normalize/path-normalize.c"));
+      assert(0 == fs_exists("./test/fixtures/path-normalize/path-normalize.h"));
+      assert(
+        0 == fs_exists("./test/fixtures/path-normalize/package.json") ||
+        0 == fs_exists("./test/fixtures/path-normalize/clib.json"));
+      clib_package_free(pkg);
+      rimraf("./test/fixtures");
+    }
+
+    it("should not install the package's development dependencies") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/trim.c@0.0.2", 0);
+      assert(pkg);
+      assert(0 == clib_package_install(pkg, "./test/fixtures/", 0));
+      assert(-1 == fs_exists("./test/fixtures/describe/"));
+      assert(-1 == fs_exists("./test/fixtures/describe/describe.h"));
+      assert(-1 == fs_exists("./test/fixtures/describe/assertion-macros.h"));
+      assert(
+        -1 == fs_exists("./test/fixtures/describe/package.json") &&
+        -1 == fs_exists("./test/fixtures/describe/clib.json"));
+      clib_package_free(pkg);
+      rimraf("./test/fixtures");
+    }
+
+    it("should install itself") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/clib-package@0.4.2", 0);
+      assert(pkg);
+      assert(0 == clib_package_install(pkg, "./test/fixtures/", 0));
+      assert(0 == fs_exists("./test/fixtures/"));
+
+      assert(0 == fs_exists("./test/fixtures/clib-package/"));
+      assert(0 == fs_exists("./test/fixtures/clib-package/clib-package.c"));
+      assert(0 == fs_exists("./test/fixtures/clib-package/clib-package.h"));
+      assert(
+        0 == fs_exists("./test/fixtures/clib-package/package.json") ||
+        0 == fs_exists("./test/fixtures/clib-package/clib.json"));
+
+      assert(0 == fs_exists("./test/fixtures/http-get/"));
+      assert(0 == fs_exists("./test/fixtures/http-get/http-get.c"));
+      assert(0 == fs_exists("./test/fixtures/http-get/http-get.h"));
+      assert(
+        0 == fs_exists("./test/fixtures/http-get/package.json") ||
+        0 == fs_exists("./test/fixtures/http-get/clib.json"));
+
+      assert(0 == fs_exists("./test/fixtures/list/"));
+      assert(0 == fs_exists("./test/fixtures/list/list.c"));
+      assert(0 == fs_exists("./test/fixtures/list/list.h"));
+      assert(
+        0 == fs_exists("./test/fixtures/list/package.json") ||
+        0 == fs_exists("./test/fixtures/list/clib.json"));
+
+      assert(0 == fs_exists("./test/fixtures/mkdirp/"));
+      assert(0 == fs_exists("./test/fixtures/mkdirp/mkdirp.c"));
+      assert(0 == fs_exists("./test/fixtures/mkdirp/mkdirp.h"));
+      assert(
+        0 == fs_exists("./test/fixtures/mkdirp/package.json") ||
+        0 == fs_exists("./test/fixtures/mkdirp/clib.json"));
+
+      assert(0 == fs_exists("./test/fixtures/parson/"));
+      assert(0 == fs_exists("./test/fixtures/parson/parson.c"));
+      assert(0 == fs_exists("./test/fixtures/parson/parson.h"));
+      assert(
+        0 == fs_exists("./test/fixtures/parson/package.json") ||
+        0 == fs_exists("./test/fixtures/parson/clib.json"));
+
+      assert(0 == fs_exists("./test/fixtures/path-join/"));
+      assert(0 == fs_exists("./test/fixtures/path-join/path-join.c"));
+      assert(0 == fs_exists("./test/fixtures/path-join/path-join.h"));
+      assert(
+        0 == fs_exists("./test/fixtures/path-join/package.json") ||
+        0 == fs_exists("./test/fixtures/path-join/clib.json"));
+
+      assert(0 == fs_exists("./test/fixtures/path-normalize/"));
+      assert(0 == fs_exists("./test/fixtures/path-normalize/path-normalize.c"));
+      assert(0 == fs_exists("./test/fixtures/path-normalize/path-normalize.h"));
+      assert(
+        0 == fs_exists("./test/fixtures/path-normalize/package.json") ||
+        0 == fs_exists("./test/fixtures/path-normalize/clib.json"));
+
+      assert(0 == fs_exists("./test/fixtures/str-ends-with/"));
+      assert(0 == fs_exists("./test/fixtures/str-ends-with/str-ends-with.c"));
+      assert(0 == fs_exists("./test/fixtures/str-ends-with/str-ends-with.h"));
+      assert(
+        0 == fs_exists("./test/fixtures/str-ends-with/package.json") ||
+        0 == fs_exists("./test/fixtures/str-ends-with/clib.json"));
+
+      assert(0 == fs_exists("./test/fixtures/str-starts-with/"));
+      assert(0 == fs_exists("./test/fixtures/str-starts-with/str-starts-with.c"));
+      assert(0 == fs_exists("./test/fixtures/str-starts-with/str-starts-with.h"));
+      assert(
+        0 == fs_exists("./test/fixtures/str-starts-with/package.json") ||
+        0 == fs_exists("./test/fixtures/str-starts-with/clib.json"));
+
+      clib_package_free(pkg);
+      rimraf("./test/fixtures");
+    }
+  }
+
+  curl_global_cleanup();
+  clib_package_cleanup();
+
+  return assert_failures();
+}
diff --git a/test/package/package-load-from-manifest b/test/package/package-load-from-manifest
new file mode 100755
index 0000000..4296ced
Binary files /dev/null and b/test/package/package-load-from-manifest differ
diff --git a/test/package/package-load-from-manifest.c b/test/package/package-load-from-manifest.c
new file mode 100644
index 0000000..b57e775
--- /dev/null
+++ b/test/package/package-load-from-manifest.c
@@ -0,0 +1,18 @@
+#include "describe/describe.h"
+#include "clib-package.h"
+
+int
+main() {
+  describe("clib_package_load_from_manifest") {
+    it("should load a package from a file if available") {
+      int verbose = 0;
+      clib_package_t* pkg = clib_package_load_from_manifest("./clib.json", verbose);
+      assert(NULL != pkg);
+      if (pkg) {
+        clib_package_free(pkg);
+      }
+    }
+  }
+
+  return assert_failures();
+}
diff --git a/test/package/package-load-manifest-file b/test/package/package-load-manifest-file
new file mode 100755
index 0000000..a3bb11f
Binary files /dev/null and b/test/package/package-load-manifest-file differ
diff --git a/test/package/package-load-manifest-file.c b/test/package/package-load-manifest-file.c
new file mode 100644
index 0000000..51c10c2
--- /dev/null
+++ b/test/package/package-load-manifest-file.c
@@ -0,0 +1,18 @@
+#include "describe/describe.h"
+#include "clib-package.h"
+
+int
+main() {
+  describe("clib_package_load_local_manifest") {
+    it("should load a local package if available") {
+      int verbose = 0;
+      clib_package_t* pkg = clib_package_load_local_manifest(verbose);
+      assert(NULL != pkg);
+      if (pkg) {
+        clib_package_free(pkg);
+      }
+    }
+  }
+
+  return assert_failures();
+}
diff --git a/test/package/package-new b/test/package/package-new
new file mode 100755
index 0000000..6ad82cd
Binary files /dev/null and b/test/package/package-new differ
diff --git a/test/package/package-new-from-slug b/test/package/package-new-from-slug
new file mode 100755
index 0000000..f2c6fc6
Binary files /dev/null and b/test/package/package-new-from-slug differ
diff --git a/test/package/package-new-from-slug.c b/test/package/package-new-from-slug.c
new file mode 100644
index 0000000..cd12455
--- /dev/null
+++ b/test/package/package-new-from-slug.c
@@ -0,0 +1,74 @@
+
+#include "describe/describe.h"
+#include "clib-package.h"
+
+int
+main() {
+  curl_global_init(CURL_GLOBAL_ALL);
+
+  describe("clib_package_new_from_slug") {
+    it("should return NULL when given a bad slug") {
+      assert(NULL == clib_package_new_from_slug(NULL, 0));
+    }
+
+    it("should return NULL when given a slug missing a name") {
+      assert(NULL == clib_package_new_from_slug("author/@version", 0));
+    }
+
+    it("should return NULL when given slug which doesn't resolve") {
+      assert(NULL == clib_package_new_from_slug("abc11234", 0));
+    }
+
+    it("should build the correct package") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/case.c@0.1.0", 0);
+      assert(pkg);
+      assert_str_equal("case", pkg->name);
+      assert_str_equal("0.1.0", pkg->version);
+      assert_str_equal("stephenmathieson/case.c", pkg->repo);
+      assert_str_equal("MIT", pkg->license);
+      assert_str_equal("String case conversion utility", pkg->description);
+      clib_package_free(pkg);
+    }
+
+    it("should force package version numbers") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/mkdirp.c@0.0.1", 0);
+      assert(pkg);
+      assert_str_equal("0.0.1", pkg->version);
+      clib_package_free(pkg);
+    }
+
+    it("should use package version if version not provided") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/mkdirp.c", 0);
+      assert(pkg);
+      assert_str_equal("0.1.5", pkg->version);
+      clib_package_free(pkg);
+    }
+
+    it("should save the package's json") {
+      clib_package_t *pkg = clib_package_new_from_slug("stephenmathieson/str-replace.c@8ca90fb", 0);
+      assert(pkg);
+      assert(pkg->json);
+
+      char expected[] =
+        "{\n"
+        "  \"name\": \"str-replace\",\n"
+        "  \"version\": \"0.0.3\",\n"
+        "  \"repo\": \"stephenmathieson/str-replace.c\",\n"
+        "  \"description\": \"String replacement in C\",\n"
+        "  \"keywords\": [ \"string\", \"replace\" ],\n"
+        "  \"license\": \"MIT\",\n"
+        "  \"src\": [\n"
+        "    \"src/str-replace.c\",\n"
+        "    \"src/str-replace.h\",\n"
+        "    \"deps/occurrences.c\",\n"
+        "    \"deps/occurrences.h\"\n"
+        "  ]\n"
+        "}\n";
+
+      assert_str_equal(expected, pkg->json);
+      clib_package_free(pkg);
+    }
+  }
+
+  return assert_failures();
+}
diff --git a/test/package/package-new.c b/test/package/package-new.c
new file mode 100644
index 0000000..25692d4
--- /dev/null
+++ b/test/package/package-new.c
@@ -0,0 +1,86 @@
+
+#include "describe/describe.h"
+#include "clib-package.h"
+
+int
+main() {
+  describe("clib_package_new") {
+    char json[] =
+      "{"
+      "  \"name\": \"foo\","
+      "  \"version\": \"1.0.0\","
+      "  \"repo\": \"foobar/foo\","
+      "  \"license\": \"mit\","
+      "  \"description\": \"lots of foo\","
+      "  \"src\": ["
+      "    \"foo.h\","
+      "    \"foo.c\""
+      "  ],"
+      "  \"dependencies\": {"
+      "    \"blah/blah\": \"1.2.3\","
+      "    \"bar\": \"*\","
+      "    \"abc/def\": \"master\""
+      "  }"
+      "}";
+
+    it("should return NULL when given broken json") {
+      assert(NULL == clib_package_new("{", 0));
+    }
+
+    it("should return NULL when given a bad string") {
+      assert(NULL == clib_package_new(NULL, 0));
+    }
+
+    it("should return a clib_package when given valid json") {
+      clib_package_t *pkg = clib_package_new(json, 0);
+      assert(pkg);
+
+      assert_str_equal(json, pkg->json);
+
+      assert_str_equal("foo", pkg->name);
+      assert_str_equal("foobar", pkg->author);
+      assert_str_equal("1.0.0", pkg->version);
+      assert_str_equal("foobar/foo", pkg->repo);
+      assert_str_equal("mit", pkg->license);
+      assert_str_equal("lots of foo", pkg->description);
+      assert(NULL == pkg->install);
+
+      assert(2 == pkg->src->len);
+      assert_str_equal("foo.h", list_at(pkg->src, 0)->val);
+      assert_str_equal("foo.c", list_at(pkg->src, 1)->val);
+
+      assert(3 == pkg->dependencies->len);
+
+      clib_package_dependency_t *dep0 = list_at(pkg->dependencies, 0)->val;
+      assert_str_equal("blah", dep0->name);
+      assert_str_equal("1.2.3", dep0->version);
+
+      clib_package_dependency_t *dep1 = list_at(pkg->dependencies, 1)->val;
+      assert_str_equal("bar", dep1->name);
+      assert_str_equal("master", dep1->version);
+
+      clib_package_dependency_t *dep2 = list_at(pkg->dependencies, 2)->val;
+      assert_str_equal("def", dep2->name);
+      assert_str_equal("master", dep2->version);
+
+      clib_package_free(pkg);
+    }
+
+    it("should support missing src") {
+      char json[] =
+        "{"
+        "  \"name\": \"foo\","
+        "  \"version\": \"1.0.0\","
+        "  \"repo\": \"foobar/foo\","
+        "  \"license\": \"mit\","
+        "  \"description\": \"lots of foo\""
+        "}";
+
+      clib_package_t *pkg = clib_package_new(json, 0);
+      assert(pkg);
+      clib_package_free(pkg);
+    }
+  }
+
+  return assert_failures();
+}
diff --git a/test/package/package-parse-author b/test/package/package-parse-author
new file mode 100755
index 0000000..2b84cb7
Binary files /dev/null and b/test/package/package-parse-author differ
diff --git a/test/package/package-parse-author.c b/test/package/package-parse-author.c
new file mode 100644
index 0000000..fd6201f
--- /dev/null
+++ b/test/package/package-parse-author.c
@@ -0,0 +1,58 @@
+
+#include <string.h>
+#include "describe/describe.h"
+#include "clib-package.h"
+
+int
+main() {
+  describe("clib_package_parse_author") {
+    char *author = NULL;
+
+    it("should return NULL when given a bad slug") {
+      assert(NULL == clib_package_parse_author(NULL));
+    }
+
+    it("should return NULL when unable to parse an author") {
+      assert(NULL == clib_package_parse_author("/"));
+      assert(NULL == clib_package_parse_author("/name"));
+      assert(NULL == clib_package_parse_author("/name@version"));
+    }
+
+    it("should default to \"clibs\"") {
+      author = clib_package_parse_author("foo");
+      assert_str_equal("clibs", author);
+      free(author);
+    }
+
+    it("should support \"author/name\"-style slugs") {
+      author = clib_package_parse_author("author/name");
+      assert_str_equal("author", author);
+      free(author);
+    }
+
+    it("should support \"author/name@version\"-slugs slugs") {
+      author = clib_package_parse_author("author/name@master");
+      assert_str_equal("author", author);
+      free(author);
+      author = clib_package_parse_author("author/name@*");
+      assert_str_equal("author", author);
+      free(author);
+    }
+
+    // this was a bug in parse-repo.c...
+    it("should not be affected after the slug is freed") {
+      char *slug = malloc(48);
+      assert(slug);
+      strcpy(slug, "author/name@version");
+
+      author = clib_package_parse_author(slug);
+
+      assert_str_equal("author", author);
+      free(slug);
+      assert_str_equal("author", author);
+      free(author);
+    }
+  }
+
+  return assert_failures();
+}
diff --git a/test/package/package-parse-name b/test/package/package-parse-name
new file mode 100755
index 0000000..619ec49
Binary files /dev/null and b/test/package/package-parse-name differ
diff --git a/test/package/package-parse-name.c b/test/package/package-parse-name.c
new file mode 100644
index 0000000..f436f3e
--- /dev/null
+++ b/test/package/package-parse-name.c
@@ -0,0 +1,58 @@
+
+#include "describe/describe.h"
+#include "clib-package.h"
+
+int
+main() {
+  describe("clib_package_parse_name") {
+    char *name = NULL;
+
+    it("should return NULL when given a bad slug") {
+      assert(NULL == clib_package_parse_name(NULL));
+    }
+
+    it("should return NULL when unable to parse a name") {
+      assert(NULL == clib_package_parse_name("/"));
+      assert(NULL == clib_package_parse_name("author/"));
+    }
+
+    it("should support the \"name\"-style slugs") {
+      name = clib_package_parse_name("name");
+      assert_str_equal("name", name);
+      free(name);
+    }
+
+    it("should support \"author/name\"-style slugs") {
+      name = clib_package_parse_name("author/name");
+      assert_str_equal("name", name);
+      free(name);
+    }
+
+    it("should support \"author/name@version\"-slugs slugs") {
+      name = clib_package_parse_name("author/name@master");
+      assert_str_equal("name", name);
+      free(name);
+
+      name = clib_package_parse_name("author/name@*");
+      assert_str_equal("name", name);
+      free(name);
+    }
+
+    // this was a bug in parse-repo.c...
+    it("should not be affected after the slug is freed") {
+      char *slug = malloc(48);
+      assert(slug);
+      strcpy(slug, "author/name@version");
+
+      char *name = clib_package_parse_name(slug);
+
+      assert_str_equal("name", name);
+      free(slug);
+
+      assert_str_equal("name", name);
+      free(name);
+    }
+  }
+
+  return assert_failures();
+}
diff --git a/test/package/package-parse-version b/test/package/package-parse-version
new file mode 100755
index 0000000..582cad8
Binary files /dev/null and b/test/package/package-parse-version differ
diff --git a/test/package/package-parse-version.c b/test/package/package-parse-version.c
new file mode 100644
index 0000000..ab0f4ce
--- /dev/null
+++ b/test/package/package-parse-version.c
@@ -0,0 +1,91 @@
+
+#include "describe/describe.h"
+#include "clib-package.h"
+
+int
+main() {
+  describe("clib_package_parse_version") {
+    char *version = NULL;
+
+    it("should return NULL when given a bad slug") {
+      assert(NULL == clib_package_parse_version(NULL));
+      assert(NULL == clib_package_parse_version(""));
+    }
+
+    it("should default to \"master\"") {
+      version = clib_package_parse_version("foo");
+      assert_str_equal("master", version);
+      free(version);
+
+      version = clib_package_parse_version("foo/bar");
+      assert_str_equal("master", version);
+      free(version);
+    }
+
+    it("should transform \"*\" to \"master\"") {
+      version = clib_package_parse_version("*");
+      assert_str_equal("master", version);
+      free(version);
+
+      version = clib_package_parse_version("foo@*");
+      assert_str_equal("master", version);
+      free(version);
+
+      version = clib_package_parse_version("foo/bar@*");
+      assert_str_equal("master", version);
+      free(version);
+    }
+
+    it("should support \"name\"-style slugs") {
+      version = clib_package_parse_version("foo");
+      assert_str_equal("master", version);
+      free(version);
+    }
+
+    it("should support \"name@version\"-style slugs") {
+      version = clib_package_parse_version("foo@bar");
+      assert_str_equal("bar", version);
+      free(version);
+
+      version = clib_package_parse_version("foo@*");
+      assert_str_equal("master", version);
+      free(version);
+
+      version = clib_package_parse_version("foo@1.2.3");
+      assert_str_equal("1.2.3", version);
+      free(version);
+    }
+
+    it("should support \"author/name@version\"-style slugs") {
+      version = clib_package_parse_version("foo/bar@baz");
+      assert_str_equal("baz", version);
+      free(version);
+
+      version = clib_package_parse_version("foo/bar@*");
+      assert_str_equal("master", version);
+      free(version);
+
+      version = clib_package_parse_version("foo/bar@1.2.3");
+      assert_str_equal("1.2.3", version);
+      free(version);
+    }
+
+    // this was a bug in parse-repo.c...
+    it("should not be affected after the slug is freed") {
+      char *slug = malloc(48);
+      assert(slug);
+      strcpy(slug, "author/name@version");
+
+      version = clib_package_parse_version(slug);
+
+      assert_str_equal("version", version);
+      free(slug);
+
+      assert_str_equal("version", version);
+
+      free(version);
+    }
+  }
+
+  return assert_failures();
+}
diff --git a/test/package/package-url b/test/package/package-url
new file mode 100755
index 0000000..e3452bc
Binary files /dev/null and b/test/package/package-url differ
diff --git a/test/package/package-url.c b/test/package/package-url.c
new file mode 100644
index 0000000..26bd37f
--- /dev/null
+++ b/test/package/package-url.c
@@ -0,0 +1,28 @@
+
+#include "describe/describe.h"
+#include "clib-package.h"
+
+int
+main() {
+  describe("clib_package_url") {
+    it("should return NULL when given a bad author") {
+      assert(NULL == clib_package_url(NULL, "name", "version"));
+    }
+
+    it("should return NULL when given a bad name") {
+      assert(NULL == clib_package_url("author", NULL, "version"));
+    }
+
+    it("should return NULL when given a bad version") {
+      assert(NULL == clib_package_url("author", "name", NULL));
+    }
+
+    it("should build a GitHub url") {
+      char *url = clib_package_url("author", "name", "version");
+      assert_str_equal("https://raw.githubusercontent.com/author/name/version", url);
+      free(url);
+    }
+  }
+
+  return assert_failures();
+}
